# coding: utf-8

"""
    Kubeflow Trainer OpenAPI Spec

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: unversioned
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from kubeflow.trainer.models.trainer_v1alpha1_job_set_template_spec import TrainerV1alpha1JobSetTemplateSpec
from kubeflow.trainer.models.trainer_v1alpha1_ml_policy import TrainerV1alpha1MLPolicy
from kubeflow.trainer.models.trainer_v1alpha1_pod_group_policy import TrainerV1alpha1PodGroupPolicy
from typing import Optional, Set
from typing_extensions import Self

class TrainerV1alpha1TrainingRuntimeSpec(BaseModel):
    """
    TrainingRuntimeSpec represents a specification of the desired training runtime.
    """ # noqa: E501
    ml_policy: Optional[TrainerV1alpha1MLPolicy] = Field(default=None, description="Configuration for the model training with ML-specific parameters.", alias="mlPolicy")
    pod_group_policy: Optional[TrainerV1alpha1PodGroupPolicy] = Field(default=None, description="Configuration for the PodGroup to enable gang-scheduling via supported plugins.", alias="podGroupPolicy")
    template: TrainerV1alpha1JobSetTemplateSpec = Field(description="JobSet template which will be used by TrainJob.")
    __properties: ClassVar[List[str]] = ["mlPolicy", "podGroupPolicy", "template"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TrainerV1alpha1TrainingRuntimeSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ml_policy
        if self.ml_policy:
            _dict['mlPolicy'] = self.ml_policy.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pod_group_policy
        if self.pod_group_policy:
            _dict['podGroupPolicy'] = self.pod_group_policy.to_dict()
        # override the default output from pydantic by calling `to_dict()` of template
        if self.template:
            _dict['template'] = self.template.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TrainerV1alpha1TrainingRuntimeSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mlPolicy": TrainerV1alpha1MLPolicy.from_dict(obj["mlPolicy"]) if obj.get("mlPolicy") is not None else None,
            "podGroupPolicy": TrainerV1alpha1PodGroupPolicy.from_dict(obj["podGroupPolicy"]) if obj.get("podGroupPolicy") is not None else None,
            "template": TrainerV1alpha1JobSetTemplateSpec.from_dict(obj["template"]) if obj.get("template") is not None else None
        })
        return _obj


